import bge

import time

#
# Whether to use the hand-written or the Haxe-transpiled version
# from haxe_lib import EyeBlinker
from eye_blink import EyeBlinker

#
# INITIALIZE
#
co = bge.logic.getCurrentController()
obj = co.owner
scene = obj.scene
obj = scene.objects["Anna"]  # Take the reference to the armature

#
#  GLOBAL VARIABELS
# print("CWD: '{}'. Scene directory: '{}'. ".format(os.getcwd(), scene_dir))
blinker = EyeBlinker()  # The parser and sequencer
viseme_weights = [0.0] * EyeBlinker.get_viseme_count()  # The always up-to-date vector of weights


# This function updates the mouth of the character
def update():
    global viseme_weights

    #
    # Update the vector of weights
    now = time.time()  # current time
    blinker.update(now, viseme_weights=viseme_weights)

    # print("Blinker updt "+str(now))
    # print(viseme_weights)

    #
    # Update the position of the driving bones
    for viseme, weight in zip(blinker.VISEMES, viseme_weights):
        ch = obj.channels['shapekey-'+viseme]
        ch.location = 0, weight, 0

    # Update the armature to move the bones (and consequently the shapekeys)
    obj.update()
